<!--
The panel that helps to organize all of the submissions by which competition
they were submitted to. This component is collapsible. 
-->
<template>
  <div :id="competition._id">
    <b-card>
      <div slot="header" @click="expanded = !expanded">
        <h6 class="mb-0" 
            id="competition_title" 
            style="font-weight: bold; float: left">
          {{ this.competition.getTitle() }}
        </h6>
        <span style="float: right;">
          <up-arrow v-show="expanded"/>
          <down-arrow v-show="!expanded"/>
        </span>
      </div>
      <b-collapse :id="'collapse'" v-model="expanded">
        <submission-component
            v-for="sub in submissions"
            :key="sub.getSubmitted().toString()"
            :submission="sub"/>
      </b-collapse>
    </b-card>
  </div>
</template>

<script>
import Submission from '@/models/Submission'
import Competition from '@/models/Competition'
import SubmissionComponent from '@/components/SubmissionComponent'
import DownArrow from 'vue-material-design-icons/chevron-down.vue'
import UpArrow from 'vue-material-design-icons/chevron-up.vue'

export default {
    name: 'app',
    components: {
        SubmissionComponent: SubmissionComponent,
        DownArrow: DownArrow,
        UpArrow: UpArrow
    },
    props: {
        competition: Competition,
        submissions:{
           type: Array,
            validator: function(value) {
                for (var i = 0; i < value.length; i++) {
                    if (!(value[i] instanceof Submission)) {
                        return false
                    }
                }
                return true
            }
        }
    },
    data: function() {
        return {
            expanded: false
        }
    }
}
</script>
